package object.staticObject;

import javafx.scene.paint.Color;
import javafx.scene.paint.PhongMaterial;
import javafx.scene.shape.Box;
import javafx.scene.transform.Translate;
import object.movableObject.MovableObject;

public class Paddle extends StaticObject {
	private Translate translate;
	
	public Paddle ( double width, double height, double depth ) {
		Box paddle = new Box ( width, height, depth );
		paddle.setMaterial ( new PhongMaterial ( Color.GREEN ) );
		super.getChildren ( ).addAll ( paddle );
		
		this.translate = new Translate ( );
		
		super.getTransforms ( ).addAll (
				this.translate
		);
	}
	
	@Override public boolean collision ( MovableObject movableObject ) {
		boolean collisionDetected = super.collision ( movableObject );
		
		if ( collisionDetected ) {
			movableObject.invertSpeedX ( );
		}
		
		return collisionDetected;
	}
	
	public void move ( double dx, double dy, double dz ) {
		this.translate.setX ( this.translate.getX ( ) + dx );
		this.translate.setY ( this.translate.getY ( ) + dy );
		this.translate.setZ ( this.translate.getZ ( ) + dz );
	}
	
	public double getZ ( ) {
		return this.translate.getZ ( );
	}
}
